
// JAVA applet sample 'DrawImagesScroll.java' for kitaro C3Lab JAVA lab
// copyright (c) by kitaro 1996
// ̃vO͂bfC[W\AvbgTvł
//
// timer    : C[Wt@C\
// images   : C[Wt@C̐
// imageX   : C[Wt@C(X = C[Wio[)
// type     : up,down,left,right
// scroll   : XN[
// delay    : XN[̑҂

import java.applet.*;
import java.awt.*;
import java.net.*;

public class DrawImagesScroll extends java.applet.Applet implements Runnable {
  String temp;
  //
  Thread thread;
  int wx,wy;
  int   timer,count,waiting;
  // background job
  MediaTracker mt;
  Graphics og;
  Image oimage;
  int images;
  Image image[];
  // scroll val;
  String type;
  int nType,nCount,nCountOrg,nCountWidth;
  int nScrollCount;
  int nDelay;
  boolean	bDlayflg;
  //
  int c1,c2;
  int x1,x2,y1,y2;
//  int ofs;

  public void init(){
	String wall;
	int i;
	temp = getParameter("timer");  if(temp==null)temp="100"; timer   = Integer.valueOf( temp ).intValue();
	temp = getParameter("wait");   if(temp==null)temp="100";  waiting = Integer.valueOf( temp ).intValue();
	temp = getParameter("images"); if(temp==null)temp="2";   images  = Integer.valueOf( temp ).intValue(); 
	temp = getParameter("wait");   if(temp==null)temp="3000";  nDelay = Integer.valueOf( temp ).intValue();

	type = getParameter("type");   if(type==null)type="up";
	temp = getParameter("scroll"); if(temp==null)temp="20";  nCountOrg= Integer.valueOf( temp ).intValue();

	mt = new MediaTracker(this);
	// Loading Images
	image = new Image[images];
	for(i=0;i<images;i++)
	{
		String name = "image"+(i+1);
		wall = getParameter(name);
		if(wall==null)
		{
			if(i==1)
				wall = "http://www.pionet.net/~kitaro/gif/title.gif";
			else
				wall = "http://www.pionet.net/~kitaro/gif/ring1.gif";
		}
		showStatus("Loading "+name+" :" +wall);
		if(wall!=null)
			try{
			image[i] = getImage(getDocumentBase(),wall); 
			mt.addImage(image[i],i);
			mt.checkID(i);
			}
			catch(Exception e){ wall=null; showStatus(e.toString());}
		else image[i]=null;
	}
	//-----------------------------------------------------------
	// offscreen
	while(true){
		mt.checkAll();
		try{mt.waitForAll();}catch(Exception e){showStatus(e.toString());}
		wx = image[0].getWidth(this);
		wy = image[0].getHeight(this);
		if(wx!=-1)break;
	}
	oimage = createImage(wx,wy);
	og = oimage.getGraphics();
	og.fillRect(0,0,wx,wy );
    count = 0;
	bDlayflg = false;
	// scroll init
	if(type=="up"   ) nType = 0;
	if(type=="down" ) nType = 1;
	if(type=="left" ) nType = 2;
	if(type=="right") nType = 3;
	// scroll count
	switch(nType){
	case 0 : case 1 : 
		nCountWidth = wy/nCountOrg;
//		ofs	   = wy%nCountOrg;
		nCount = nCountWidth; if( (wy%nCountOrg)!=0)nCountOrg++; break;
	case 2 : case 3 : 
		nCountWidth = wx/nCountOrg;
//		ofs	   = wx%nCountOrg;
		nCount = nCountWidth; if( (wx%nCountOrg)!=0)nCountOrg++; break;
	}

	nCountOrg++;
	nScrollCount=0;
  }
 public int scroll(int count){
		x1 = x2 = y1 = y2 = 0;
		c1 = count;
		c2 = count+1; if(c2>=images)c2=0;
		switch(nType){
		case 0 :
			y1 = nCountWidth*nScrollCount;
			if(y1 >= wy) y1=wy;
			y1 = 0 - y1; y2 = y1 + wy; break;
		case 1 :
			y1 = nCountWidth*nScrollCount;
			if(y1 >= wy) y1=wy;
			y2 = y1 - wy; break;		
		case 2 : 
			x1 = nCountWidth*nScrollCount;
			if(x1 >= wx) x1=wx;
			x1 = 0 - x1; x2 = x1 + wx; break;
		case 3 :
			x1 = nCountWidth*nScrollCount;
			if(x1 >= wx) x1=wx;
			x2 = x1 - wx; break;		
		}
		if(++nScrollCount>nCountOrg) {nScrollCount=0; return 1;}
		return 0;
	}
 public void off_update(){
	if( scroll(count)!=0){
		if( ++count >= images) count=0; 
		bDlayflg = true;
		}
	}
 //*******************************************************************
  public void start(){
	thread = new Thread(this);
	thread.start();
  }
  public void run (){
    try{mt.waitForAll();}
	catch(InterruptedException e){showStatus(e.toString());return;}
	while(true)
	{
		bDlayflg = false;
		try{ thread.sleep(timer);}
		catch(Exception e){showStatus(e.toString());}
		off_update();
		if(bDlayflg==true)
		{
			try{ thread.sleep(nDelay);}
			catch(Exception e){showStatus(e.toString());}
		}
		repaint();
	}  
  }
  public void paint(Graphics g){
	og.drawImage(image[c1],x1,y1,new Color(0),this);
	og.drawImage(image[c2],x2,y2,new Color(0),this);
	g.drawImage(oimage,0,-2,new Color(0),this); 
  }
  public void update(Graphics g){paint(g); }
}
